//   

#include <stdio.h>

#define P         257		//  
#define MAX_VALUE 65535
#define MAX_FREQ  16383 
#define FIRST     16384
#define HALF      32768
#define THIRD     49152

typedef unsigned char BYTE;

class Encoder{
	int follow,h,l;					//  
	BYTE byte,byte_shift;			//    
	int cum_freq[P+1];				//!<   (  )
	void WriteBit(FILE*,int bit);	//!<    
	void WriteBits(FILE*,int bit);	//!<  
	void Init(FILE*,FILE*);			//!<  
	void EncodeSym(FILE*,int);		//!<   
public:
	void Work(char*,char*);
};


void Encoder::Init(FILE *input,FILE *output)
{
	int sym,n,cum,freq[P+1];
	for(n=0; n<=P; n++) freq[n]=1;
	for(;;) {
		sym=fgetc(input);
		if(sym==EOF) break;
		freq[sym+1]++;
	}
	cum=0;
	for(n=P; n>=0; n--)
	{
		cum_freq[n]=cum;
		cum+=freq[n];
	}
	while(cum_freq[0]>=MAX_FREQ)
	{
		cum=0;
		for(n=P; n>=0; n--)
		{
			freq[n]=(freq[n]+1)/2;
			cum_freq[n]=cum;
			cum+=freq[n];
		}
	}
	rewind(input);
	for(n=0; n<P; n++) fwrite(&cum_freq[n],1,2,output);
}


void Encoder::WriteBit(FILE *output,int bit)
{
	if(bit) byte|=byte_shift;
	byte_shift>>=1;
	if(byte_shift) return;
	fputc(byte,output);
	byte_shift=0x80; byte=0;
}

void Encoder::WriteBits(FILE *output,int bit)
{
	WriteBit(output,bit);
	while(follow) WriteBit(output,!bit),follow--;
}




void Encoder::EncodeSym(FILE *output,int sym)
{
	int range=h-l+1;
	h=l+(range*cum_freq[sym])/cum_freq[0]-1;
	l=l+(range*cum_freq[sym+1])/cum_freq[0];
	for(;;)
	{
		if(h<HALF) WriteBits(output,0);
		else if(l>=HALF) WriteBits(output,1),l-=HALF,h-=HALF;
		else if(l>=FIRST && h<THIRD) follow++,l-=FIRST,h-=FIRST;
		else break;
		l<<=1,h=1+(h<<1);
	}
}


void Encoder::Work(char *in_name,char *out_name)
{
	FILE *input =fopen(in_name,"rb");
	FILE *output=fopen(out_name,"wb");
	if(!input || !output) {printf("io error\n\a");return;}
	byte=0; byte_shift=0x80;
	Init(input,output);
	follow=0,l=0,h=MAX_VALUE;
	int sym;
	for(;;) {
		sym=getc(input);
		if(sym==EOF) break;
		EncodeSym(output,sym);
	}
	EncodeSym(output,P-1);
	follow++; WriteBits(output,l<FIRST?0:1);	//   
	if(byte_shift!=1) fputc(byte,output);	//   
	fclose(output);
	fclose(input);
}



void main(int c,char **l)
{
	Encoder encoder;
	if(c!=3) printf("Usage: %s <in_file> <out_file>\n",l[0]);
	else encoder.Work(l[1],l[2]);
}


